unit scrDemoAppend;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, VCL.TMSFNCTypes, VCL.TMSFNCUtils,
  VCL.TMSFNCGraphics, VCL.TMSFNCGraphicsTypes, VCL.TMSFNCGridCell,
  VCL.TMSFNCGridOptions, Data.DB, WEBLib.DB, WEBLib.CDS,
  VCL.TMSFNCCustomControl, VCL.TMSFNCCustomScrollControl, VCL.TMSFNCGridData,
  VCL.TMSFNCCustomGrid, VCL.TMSFNCGrid, Vcl.Controls, VCL.TMSFNCCustomComponent,
  VCL.TMSFNCGridDatabaseAdapter, Vcl.StdCtrls, WEBLib.StdCtrls, WebLib.JSON,
  jsdelphisystem, uSesPickerLookup, WEBLib.REST;

type
  TForm4 = class(TWebForm)
    Adapter: TTMSFNCGridDatabaseAdapter;
    Grid: TTMSFNCGrid;
    DataSet: TWebClientDataSet;
    DataSource: TWebDataSource;
    DataSetColonna1: TIntegerField;
    DataSetColonna2: TIntegerField;
    DataSetColonna3: TIntegerField;
    DataSetColonna4: TIntegerField;
    DataSetColonna5: TIntegerField;
    btnAdd: TWebButton;
    btnAlign: TWebButton;
    WebLabel3: TWebLabel;
    WebMemo1: TWebMemo;
    WebMemo2: TWebMemo;
    procedure btnAddClick(Sender: TObject);
    procedure WebFormCreate(Sender: TObject);
    procedure DataSetNewRecord(DataSet: TDataSet);
    procedure btnAlignClick(Sender: TObject);
    procedure GridGetCellLayout(Sender: TObject; ACol, ARow: Integer;
      ALayout: TTMSFNCGridCellLayout; ACellState: TTMSFNCGridCellState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form4: TForm4;

implementation

{$R *.dfm}

procedure TForm4.btnAddClick(Sender: TObject);
begin //Add new record
DataSet.Append;
end;

procedure TForm4.btnAlignClick(Sender: TObject);
begin
//if I set the horizontal alignment in the object inspector, this setting doesn't works.
Grid.Appearance.FixedLayout.TextAlign := gtaCenter;      //this setting doesn't works
Grid.Columns[3].HorzAlignment := gtaTrailing;            //this setting align all column's cell (also fixed rows)
//I'm forced to set event "OnGetCellLayout"
end;

procedure TForm4.DataSetNewRecord(DataSet: TDataSet);
begin
DataSet.FieldByName('Colonna1').Value := 1;

end;

procedure TForm4.GridGetCellLayout(Sender: TObject; ACol, ARow: Integer;
  ALayout: TTMSFNCGridCellLayout; ACellState: TTMSFNCGridCellState);
begin
if ARow < Grid.FixedRows then
   ALayout.TextAlign := TTMSFNCGraphicsTextAlign.gtaCenter
//else
//   ALayout.TextAlign := TTMSFNCGraphicsTextAlign.gtaTrailing;
end;

procedure TForm4.WebFormCreate(Sender: TObject);
var
tmpJSON : String;
tmpList : TStringList;
tmpJSValue : JSValue;
tmpReq : TJSXMLHttpRequest;

begin  //Load dataset's data from json
tmpList := TStringList.Create;
tmpList.LoadFromFile('JSONTest.json');
tmpJSON := tmpList.Text;

if tmpJSON <> '' then
   begin
   tmpJSValue := TJSJSON.Parse(tmpJSON);
   DataSet.Active := False;
   DataSet.Rows :=  ToArray(tmpJSValue);
   DataSet.Active := True;
   end
else
   ShowMessage('Error');



end;

end.
